package be.ugent.dict.ugentssoauth.demo.servlet;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jasig.cas.client.authentication.AttributePrincipal;

/**
 * Servlet implementation class DemoServlet
 */
public class DemoServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	private static int count = 0;

	public DemoServlet() {
		super();
	}

	protected void service(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		
		response.setContentType("text/html");
		ServletOutputStream out = response.getOutputStream();
		out.println("<html>");
		out.println("<head>");
		out.println("<title>Hello World</title>");
		out.println("</head>");
		out.println("<body>");
		out.println("<h1>Hello World</h1>");
		out.println("You are succesfully logged in as user <b>"	+ request.getRemoteUser() + "</b><br/><br/>");

		AttributePrincipal principal = (AttributePrincipal) request.getUserPrincipal();
		if (principal != null) {
			Map attributes = principal.getAttributes();
	
			if (attributes.size() > 0) {
	
				out.println("You have " + attributes.size()	+ " attributes : <br/>");
				Iterator keyIterator = attributes.keySet().iterator();
	
				while (keyIterator.hasNext()) {
					Object key = keyIterator.next();
					Object value = attributes.get(key);
					out.println("<b>" + key + "</b>" + " : " + value + "<br/>");
				}
			} else {
				out.println("You have no attributes set");
			}
		} else {
			out.println("Principal is null!");
		}

		out.println("<br/><br/><br/>");
		out.println("This page is " + ++count + " times loaded");
		out.println("<br/><br/><br/>");
		out.println("<a href=\"https://login.ugent.be/logout\">Logout</a>");
		out.println("</body>");
		out.println("</html>");
		out.flush();
	}

}
